/*
 *		MEUBLES.INC (INSIDE PROJECT)
 *
 *	Alors des fichiers 'meubles.inc', j'ai déja du en
 *	écrire une bonne dizaine. Peut-etre un jour, je
 *	prendrais le temps de rassembler tout ces trucs.
 *				--- tTh, avril 2022 ---
 */

/*    ======================================================    */
/*
 *	8 octobre 2022 : des fauteuils pour mettre devan l'écran de
 *			la rotonde.
 */

#declare Fauteuil_Cinema_A = object
{
#local DFC = 0.25;
union {
	box { <-DFC, 0.33, -DFC>, <DFC, 0.42, DFC> }
	box { <-DFC, 0.22, -DFC>, <DFC, 0.92, -(DFC+0.03)> }
	}
texture { CYAN_CRACRA scale 5 }
#undef DFC
}
/*    ======================================================    */
/*
 *		nouveau du 1er janvier 2020+2
 *		au 64 rue Ernest Renan
 */

#declare  TB_long = 1.60;
#declare  TB_larg = 0.92;
#declare  TB_haut = 0.51;

#declare Table_Basse_pied = object
{
#local D = 0.029;
box { <-D, 0, -D>, <D, TB_haut, D> }
texture {
	pigment { color Gray60 }
	finish { phong PHONG specular SPECULAR }
	}
}

#declare Table_Basse_les_pieds = object
{
#local Ex = (TB_larg/2) - 0.10;
#local Ez = (TB_long/2) - 0.24;
union	{
	object { Table_Basse_pied translate <-Ex, 0, -Ez> }
	object { Table_Basse_pied translate < Ex, 0, -Ez> }
	object { Table_Basse_pied translate <-Ex, 0,  Ez> }
	object { Table_Basse_pied translate < Ex, 0,  Ez> }

	union {
		#local H = 0.122;
		#local D = 0.015;
		cylinder { <-Ex, H, -Ez>, < Ex, H,  Ez>, D }
		cylinder { < Ex, H, -Ez>, <-Ex, H,  Ez>, D }
		texture {
			pigment { color Gray35 }
			finish { phong PHONG specular SPECULAR }
			}
		}
	}
}

#declare Table_Basse_plateau = object
{
#local szx = TB_larg / 2.0;
#local szz = TB_long / 2.0;
union {
	box {
		<-szx, 0, -szz>, <szx, 0.04, szz> 
		texture { T_Wood4 scale 2.2 rotate <6, 2,  5> }
		}
	#local ee = 0.15;
	box	{
		<-(szx-ee), 0, -(szz-ee)>, <szx-ee, 0.0404, szz-ee> 
		texture { T_Wood2 scale 1.9 rotate <6, 99,  2> }
		}
	}
}

#declare Table_Basse = object
{
union	{
	object { Table_Basse_les_pieds }
	object { Table_Basse_plateau translate y*TB_haut }
	}
}


/*    ======================================================    */

#local Eax = 0.12;

#declare Anneau_Axe = object
{
difference {
	cylinder { <0, -0.03, 0>, <0, 0.03, 0>, Eax * 1.25 }
	cylinder { <0, -0.09, 0>, <0, 0.09, 0>, Eax * 0.75 }
	}
}

#macro Branche_Lustre_B(couleur)
object {
#local Rblb = 0.030;
merge	{
	cylinder { <0, 0, 0>, <0, 0, 0.60>, Rblb}

	intersection {
		torus { 0.15 Rblb }
		box { < 2, -2,  2>, <0, 2, 0> }
		rotate 90*z translate <0, -0.15, 0.60>
		}

	intersection {
		torus { 0.15 Rblb }
		box { <-2, -2, -2>, <0, 2, 2> }
		rotate 90*z translate <0, -0.15, 0.90>
		}

	merge	{
		cone { <0, 0.00, 0>, Rblb, <0, 0.20, 0>, Rblb*1.717 }
		cone { <0, 0.30, 0>, Rblb, <0, 0.20, 0>, Rblb*1.717 }
		translate <0, -0.15, 1.05>
		}

	}
texture	{
	pigment { color couleur }
	finish { phong PHONG specular SPECULAR }
	}
}
#end

#declare Ampoule = object
{
sphere { <0, 0, 0>, 0.09 scale <1, 1.5, 1> }
texture {
	pigment { color Yellow }
	finish { phong PHONG specular SPECULAR emission 1.33 }
	}
no_shadow
}

#declare Les_Branches_Lustre_B = object
{
union	{
	// #for (foo, 0, 360, 51.428571428571)
	#local mc = mod(clock/2, 7);
	#for (foo, 0, 7, 1)
	  #local A = foo * 51.428571428571;
	  #local R = radians(A);
	  object { Branche_Lustre_B(GreenCopper)  rotate y*A }
	  #if (foo = mc)
	    #local dx = 1.05 * sin(R);
	    #local dz = 1.05 * cos(R);
            object { Ampoule translate <dx, 0.28, dz> }
	  #end
	#end
	}
}

#declare Axe_du_Lustre_B = object
{
union	{
	/* haut */
	object { Anneau_Axe translate 3.00*y }
	object { Anneau_Axe translate 2.65*y }

	/* milieu */
	#for (foo, 0, 360, 51.428571428571)
	  #local dx = Eax * sin(radians(foo));
	  #local dz = Eax * cos(radians(foo));
	  cylinder { <0, -0.25, 0>, <0, 3.0, 0>, 0.015 
			translate <dx, 0.0, dz> }
	#end

	/* bas */
	object { Anneau_Axe translate -0.25*y }
	object { Anneau_Axe translate  0.00*y }
	}
texture {
	pigment { color Red }
	finish { phong PHONG specular SPECULAR }
	}
}

#declare Lustre_B = object
{
union	{
	object { Les_Branches_Lustre_B }
	object { Axe_du_Lustre_B }
	}
}

/*    ======================================================    */

#declare T_bar = 0.92;
#declare H_bar = 1.13;

#declare Barriere_Aa = object
{
union	{
	sphere { 0, 0.031 scale <1, 0.4, 1> translate <0, H_bar , 0> }
	cylinder { <0, 0, 0>, <0, H_bar , 0>, 0.031 }
	cylinder { <0, 0, 0>, <0, 0.02, 0>, 0.14 }
	}
texture {
	pigment { color DarkGreen }
	finish { phong PHONG specular SPECULAR }
	}
}

#declare Barriere_Ab = object
{
union	{
	cylinder { <0, 0.85, 0>, <0, 1.05, 0>, 0.035 }
	cylinder { <0, 0.61, 0>, <0, 0.69, 0>, 0.035 }
	}
texture { T_Copper_3D }
}

#declare Barriere_A = object
{
union {
	object { Barriere_Aa }
	object { Barriere_Ab }
	}
}

#declare Barriere_B = object
{
box { <-0.01, -0.058, -T_bar>, < 0.01,  0.058,  T_bar> }
texture	{
	pigment { checker
			pigment { color Red }
			pigment { color White }
		 }
	scale 0.08 rotate x*90
	finish { phong PHONG specular SPECULAR }
	}
}

#declare Barriere = object
{
union	{
	object { Barriere_A translate -T_bar*z }
	object { Barriere_B translate  0.95*y }
	object { Barriere_B translate  0.65*y }
	object { Barriere_A translate  T_bar*z }
	}
}

/*    ======================================================    */
/*	nouveau 29 avril 2022		*/
#local E_Barr2 = 0.012;
#local L_Barr2 = 0.650;
#local H_Barr2 = 0.750;

#declare Barriere_2_grille = object
{
difference {
	box { <-E_Barr2, 0.02, -L_Barr2>, <E_Barr2, H_Barr2, L_Barr2> }
	#local Xe = L_Barr2 - 0.11;
	#local Rh = 0.050;
	#local Rb = 0.036;
	#for (foo, 0.071, Xe, 0.14)
	  cylinder { <-1, 0, 0>, <1, 0, 0>, Rb translate <0, 0.67,  foo> }
	  cylinder { <-1, 0, 0>, <1, 0, 0>, Rb translate <0, 0.67, -foo> }
	  cylinder { <-1, 0, 0>, <1, 0, 0>, Rb translate <0, 0.51,  foo> }
	  cylinder { <-1, 0, 0>, <1, 0, 0>, Rb translate <0, 0.51, -foo> }
	  cylinder { <-1, 0, 0>, <1, 0, 0>, Rh translate <0, 0.38,  foo> }
	  cylinder { <-1, 0, 0>, <1, 0, 0>, Rh translate <0, 0.38, -foo> }
	  cylinder { <-1, 0, 0>, <1, 0, 0>, Rb translate <0, 0.23,  foo> }
	  cylinder { <-1, 0, 0>, <1, 0, 0>, Rb translate <0, 0.23, -foo> }
	  cylinder { <-1, 0, 0>, <1, 0, 0>, Rb translate <0, 0.14,  foo> }
	  cylinder { <-1, 0, 0>, <1, 0, 0>, Rb translate <0, 0.14, -foo> }
	#end
	}
texture	{
	pigment { color rgb <0.60, 0.95, 0.60> }
	finish { phong PHONG  specular SPECULAR }
	}
}

/*   ici le pied de la barriere 2 */
#declare Barriere_2_pied = object
{
union	{
	box { <-0.07, 0, -0.07>, < 0.07, 0.02,          0.07> }
	box { <-0.02, 0, -0.02>, < 0.02, H_Barr2+0.15,  0.02> }
	}
texture	{
	pigment { color rgb <0.50, 0.85, 0.50>  }
	finish { phong PHONG  specular SPECULAR  }
	}
}

#declare Barriere_2 = object
{
union	{
	#local Zt = L_Barr2 + 0.04;
	object { Barriere_2_pied   translate -z*Zt	}
	object { Barriere_2_grille translate  y*0.10    }
	object { Barriere_2_pied   translate  z*Zt 	}
	}
}

#declare Cercle_Barriere_2 = object
{
union	{
	#for (foo, 0, 270, 30)
	  #local Rayon = 3.30;
	  #local Dx = Rayon * sin(radians(foo));
	  #local Dz = Rayon * cos(radians(foo));
	  object { Barriere_2 rotate (90+foo)*y
				translate < Dx, 0, Dz> } 
	#end
	#undef Rayon
	}
}

/*    ======================================================    */
/*
 *	encore une autre barrière - Tue 18 Oct 2022 05:44:13 PM CEST
 */

#declare Barriere_4 = object
{
#local SB4 = 1.40;
#local SBz = SB4 + 0.03;
#local   H = 1.15;
merge {
	cylinder { <0, H , -SBz>, <0, H,  SBz>, 0.04 }
	sphere { <0, H, -SBz>, 0.04 }
	sphere { <0, H,  SBz>, 0.04 }

	/* les verticales */
	cylinder { <0, 0, -SB4>, <0, H, -SB4>, 0.03 }
	cylinder { <0, 0,  SB4>, <0, H,  SB4>, 0.03 }
	cylinder { <0, 0, -SB4>, <0, 0.015, -SB4>, 0.09 }
	cylinder { <0, 0,  SB4>, <0, 0.015,  SB4>, 0.09 }

	/* les diagonales */
	cylinder { <0, 0.95, -SB4>, <0, 0.95,  SB4>, 0.03 }
	cylinder { <0, 0.11, -SB4>, <0, 0.95,  SB4>, 0.03 }
	cylinder { <0, 0.95, -SB4>, <0, 0.11,  SB4>, 0.03 }
	cylinder { <0, 0.11, -SB4>, <0, 0.11,  SB4>, 0.03 }
	}
texture { MON_VERT_INDUS scale 1.19 }
}

#declare Rang_Barriere_4 = object
{
union	{
	object { Barriere_4 }
	object { Barriere_4 translate -3.16*z }
	object { Barriere_4 translate  3.15*z }
	}
}
/*    ======================================================    */

#declare AbatJour = object
{
#local R_abja = 0.13;
#local R_abjb = R_abja + 0.05;
#local R_abjc = R_abja;
#local H_abj = 0.21;
#local H2 = H_abj + 0.06;
union	{
	torus { R_abja, 0.006 }
	#for (foo, 0, 360, 8)
	  #local dxa = R_abja * sin(radians(foo));
	  #local dza = R_abja * cos(radians(foo));
	  #local dxb = R_abjb * sin(radians(foo));
	  #local dzb = R_abjb * cos(radians(foo));
	  cylinder { <dxa, 0, dza>, <dxb, H_abj, dzb>, 0.002 }
	#end

	torus { R_abjb, 0.004 translate H_abj*y }
	#for (foo, 0, 360, 8)
	  #local dxa = R_abjb * sin(radians(foo));
	  #local dza = R_abjb * cos(radians(foo));
	  #local dxb = R_abjc * sin(radians(foo));
	  #local dzb = R_abjc * cos(radians(foo));
	  cylinder { <dxa, H_abj, dza>, <dxb, H2, dzb>, 0.002 }
	#end

	torus { R_abjc, 0.006 translate H2*y }
	}
texture {
	pigment { color Gray90 }
	finish { phong PHONG specular SPECULAR }
	}
}

#declare Une_Branche = object
{
merge {
	#local E = 1.75;
	cylinder { <0, 0, E>, <0, 0, 0>, 0.04 scale <0.555, 1, 1> }
	cylinder { <0, -0.10, E>, <0, 0.20, E>, 0.04 }
	sphere   { <0, 0, 0>, 0.04	scale <1, 0.666, 1> 
					translate <0, -0.10, E> }
	cylinder { <0, 0, E*0.46>, <0, 0.64, 0>, 0.01 }
	}
texture {
	pigment { color Turquoise }
	finish { phong PHONG specular SPECULAR }
	}
}

#declare Les_Branches = object
{
union	{
	#for (foo, 0, 360, 51.428571428571)
	  object { Une_Branche rotate y*foo }
	  #local dx = 1.75 * sin(radians(foo));
	  #local dz = 1.75 * cos(radians(foo));
	  object { AbatJour translate <dx, 0.20, dz> }
	#end
	}
}

#declare Axe_du_Lustre_A = object
{
merge {
	sphere { 0, 0.10 scale <2,1,2> translate y*3.08 }
	cylinder { <0, -0.25, 0>, <0, 3.0, 0>,  0.045	}
	cylinder { <0, -0.06, 0>, <0, 0.06, 0>, 0.085	}
	cylinder { <0,  0.55, 0>, <0, 0.65, 0>, 0.065	}
	difference {
		sphere { <0, 0, 0>, 0.10 }
		torus  { 0.10, 0.01 scale <1, 2.2, 1> }
		translate -0.25*y
		}
	cone { <0, -0.25, 0>, 0.07, <0, -0.55, 0>, 0.00000000001 }
	}
texture {
	pigment { color NavyBlue }
	finish { phong PHONG specular SPECULAR }
	}
}

#declare Lustre_A = object
{
union	{
	object { Les_Branches }
	object { Axe_du_Lustre_A }
	}
}

/*    ======================================================    */
/*
 *		Espace disponible
 */

// 9 main 2023 : tentative de guéridon (coucou Valensole :)

#local HG  = 1.20;	// hauteur gueridon
#local RGP = 0.40;	// rayon gueridon plateau

#declare Gueridon_0_pied = object
{
//	FIXME !
union {
	cylinder { 0, HG*y 0.03 }
	cylinder { 0, 0.07*y 0.16 }
	cylinder { 0, 0.04*y 0.22 }
	}
texture { MON_VERT_INDUS scale 0.51 }
}

#declare Gueridon_0_plateau_planche = object
{
cylinder { -0.01*y, 0.015*y  RGP }
texture { T_Stone31 scale 0.28 }
}

#declare Gueridon_0_plateau_tour = object
{
torus { RGP, 0.0085 scale <1, 1.97, 1> }
texture { T_Copper_3A }
}

#declare Gueridon_0_plateau = object
{
union	{
	object { Gueridon_0_plateau_planche }
	object { Gueridon_0_plateau_tour    }
	}
translate y*HG
}

#declare Gueridon_0_repose_pied = object
{
union	{
	torus { 0.22 0.013 }
	#for (foo, 0, 360, 72)

	  #declare Dx = 0.22 * sin(radians(foo));
	  #declare Dz = 0.22 * cos(radians(foo));
	  cylinder { <Dx, 0, Dz>, <0, -0.05, 0>, 0.008 }
	#end
 	}
texture { T_Copper_3A }

translate y*0.30
}

#declare Gueridon_0 = object
{
union	{
	object { Gueridon_0_pied		}
	object { Gueridon_0_plateau		}
	object { Gueridon_0_repose_pied		}
	}
}

/*    ======================================================    */

#local Pied_Chaise_AR = object
{
box { <-0.015, 0, -0.02>, <0.015, 1.0, 0.02> }
}

#local Pied_Chaise_AV = object
{
box { <-0.02, 0, -0.02>, <0.02, 0.40, 0.02> }
}

#local Barreau_De_Chaise = object
{
cylinder { <-0.20, 0, 0>, <0.20, 0, 0>, 0.011 }
translate y*0.11
}

#local Pieds_Chaise = object
{
union	{
	object { Pied_Chaise_AR translate <-0.20, 0, -0.20> }
	object { Pied_Chaise_AR translate < 0.20, 0, -0.20> }
	object { Pied_Chaise_AV translate <-0.20, 0,  0.20> }
	object { Pied_Chaise_AV translate < 0.20, 0,  0.20> }

	object { Barreau_De_Chaise rotate y*90 translate -x*0.20 }
	object { Barreau_De_Chaise rotate y*90 translate  x*0.20 }
	object { Barreau_De_Chaise translate  z*0.20 }
	object { Barreau_De_Chaise translate -z*0.20 }

	}
}

#declare Assise_Chaise = object
{
#local E = 0.227;
#local e = E - 0.07;
difference {
	box { <-E, -0.015, -E>, <E, 0.015, E> }
	box { <-e,  0.008, -e>, <e, 0.025, e> }
	}
translate y*0.41
}

#declare Dossier_Chaise_a = object
{
difference {
	box { <-0.20, 0, -0.01>, <0.20, 0.12, 0.01> }
	cylinder { <0, 0.07, -0.3>, <0, 0.06, 0.3>, 0.036 }
	#local ex = 0.12;
	cylinder { < ex, 0.07, -0.3>, < ex, 0.06, 0.3>, 0.021 }
	cylinder { <-ex, 0.07, -0.3>, <-ex, 0.06, 0.3>, 0.021 }
	}
}

#declare Dossier_Chaise = object
{
union	{
	object { Dossier_Chaise_a translate  y*0.10 }
	object { Dossier_Chaise_a translate -y*0.10 }
	}
translate <0, 0.71, -0.20>
}

#declare Chaise_Jaune = object
{
union	{
	object { Pieds_Chaise }
	object { Assise_Chaise }
	object { Dossier_Chaise   }
	}
texture {
	pigment { color Yellow*0.85 }
	normal   { granite 0.42 scale 1.2            }
	finish { phong PHONG specular SPECULAR }
	}
}

#declare Chaise_1 = object
{
union	{
	object { Pieds_Chaise   pigment { color CoolCopper  } }
	object { Assise_Chaise  pigment { color Scarlet     } }
	object { Dossier_Chaise pigment { color LimeGreen   } }
	}
finish { phong PHONG specular SPECULAR }
}

#declare Chaise_Rasta = object
{
union	{
	object { Pieds_Chaise   pigment { color Red*0.7  	} }
	object { Assise_Chaise  pigment { color Yellow*0.7	} }
	object { Dossier_Chaise pigment { color Green*0.7	} }
	}
finish { phong PHONG specular SPECULAR }
}

#declare Chaise_Grise = object
{
union	{
	object { Pieds_Chaise   pigment { color Gray40  	} }
	object { Assise_Chaise  pigment { color Gray20		} }
	object { Dossier_Chaise pigment { color Gray30		} }
	}
finish { phong PHONG specular SPECULAR }
}

/*    ======================================================    */

#declare Cercle_de_chaises = object
{
union	{
	#for (foo, 0, 360, 25.71428571)
	  #local Rayon = 2.30;
	  #local Dx = Rayon * sin(radians(foo));
	  #local Dz = Rayon * cos(radians(foo));
	  object { Chaise_Rasta rotate (184+foo)*y
				translate < Dx, 0, Dz> } 
	#end
	}
#undef Rayon
#undef Dx
#undef Dz
}

/*    ======================================================    */

#declare H_tabouret = 0.40;

#declare Pied_Tabouret = object
{
cylinder { <0.06, 0, 0>, <0, H_tabouret, 0>, 0.013 }
}

#declare Assise_Tabouret = object
{
#local Ra = 0.17;
#local Ea = 0.015;
merge	{
	cylinder { <0, 0, 0>, <0, Ea, 0>, Ra }
	torus { Ra, Ea }
	}
}

#macro Un_Tabouret(Couleur)
union	{
	object { Assise_Tabouret translate y*H_tabouret }

	#local E = 0.092;
	object { Pied_Tabouret rotate 135*y translate <-E, 0, -E> }
	object { Pied_Tabouret rotate  45*y translate < E, 0, -E> }
	object { Pied_Tabouret rotate 225*y translate <-E, 0,  E> }
	object { Pied_Tabouret rotate 315*y translate < E, 0,  E> }

	#local E = 0.120;
	#local H = 0.10;
	cylinder { <-E, H, -E>, < E, H, -E>, 0.008 }
	cylinder { <-E, H,  E>, < E, H,  E>, 0.008 }

	#local E = 0.118;
	#local H = H + 0.05;
	cylinder { <-E, H, -E>, <-E, H,  E>, 0.008 }
	cylinder { < E, H, -E>, < E, H,  E>, 0.008 }
	texture {
		pigment { color Couleur }
		finish { phong PHONG specular SPECULAR }
		}

	}
#end

/*    ======================================================    */

#declare H_table  = 1.05;
#declare E_table  = 0.045;	// epaisseur plateau
#declare La_table = 0.55;
#declare Lo_table = 1.30;

#declare Plateau_table = object
{
box { <-La_table, 0, -Lo_table>, <La_table, E_table, Lo_table> }
texture { T_Wood2 rotate <1, 3, 5> }
}

#declare Pied_table_A = object
{
#local Tpt = 0.045;
box { <-Tpt, 0, -Tpt>, <Tpt, H_table, Tpt> }
texture { T_Wood5 scale 1.6 rotate <89, 3, 5> }
}

/* entretoise aux deux bouts */
#local Pied_table_B = object
{
#local Tx = La_table - 0.25;
box { <-Tx, 0, -0.025>, <Tx, 0.08, 0.025> }
texture { T_Wood5 scale 1.6 rotate <0, 3, 85> }
}

#local Longeron_table = object
{
#local tz = Lo_table - 0.25;
box { <-0.02, 0, -tz>, <0.02, -0.15, tz> }
texture { T_Wood5 scale 1.6 rotate <90, 3, -5> }
}

#declare Les_pieds_de_la_table = object
{
union	{
	#local dx = La_table - 0.20;
	#local dz = Lo_table - 0.20;
	object { Pied_table_A    translate <-dx, 0, -dz> }
	object { Pied_table_A    translate < dx, 0, -dz> }
	object { Pied_table_A    translate <-dx, 0,  dz> }
	object { Pied_table_A    translate < dx, 0,  dz> }

	object { Pied_table_B    translate <0, 0.11, -dz> }
	object { Pied_table_B    translate <0, 0.11,  dz> }
	#local h2 = H_table - 0.18;
	object { Pied_table_B    translate <0, h2, -dz> }
	object { Pied_table_B    translate <0, h2,  dz> }

	object { Longeron_table  translate <-dx, H_table, 0> }
	object { Longeron_table  translate < dx, H_table, 0> }
	}
}

/*    ------------------------------------------------------    */

#declare Une_Table = object
{
union	{
	object { Plateau_table translate y*H_table }
	object { Les_pieds_de_la_table }
	}
}

/*    ======================================================    */

#declare Pied_Table_Ronde = object
{
cone { <0, 0, 0>, 0.025, <0, H_table, 0>, 0.04 }

texture { T_Wood32 rotate x*90 }
}

#declare Plateau_Table_Ronde = object
{
cylinder { <0, H_table, 0>, <0, H_table+E_table, 0>, 0.93 }
texture { T_Wood32 scale 1.666 rotate <6, 28, 9> }
}

#local Eptr = 0.52;	/* ecartement des pieds */

#declare Longeron_Table_Ronde = object
{
box { <-0.01, H_table-0.16, -Eptr>, <0.01, H_table, Eptr> }
// pigment { color Cyan }
texture { T_Wood35 }
}

#declare Table_Ronde = object
{
union	{
	object { Plateau_Table_Ronde }

	#local Ep = 0.53;
	object { Pied_Table_Ronde translate <-Eptr, 0, -Eptr> }
	object { Pied_Table_Ronde translate < Eptr, 0, -Eptr> }
	object { Pied_Table_Ronde translate <-Eptr, 0,  Eptr> }
	object { Pied_Table_Ronde translate < Eptr, 0,  Eptr> }

	object { Longeron_Table_Ronde translate -x*Eptr }
	object { Longeron_Table_Ronde rotate y*90 translate -z*Eptr }
	object { Longeron_Table_Ronde translate  x*Eptr }
	object { Longeron_Table_Ronde rotate y*90 translate  z*Eptr }
	}
}

/*    ======================================================    */

#declare H_banc = 0.45;
#declare La_banc = 0.16;
#declare Lo_banc = 0.70;

#declare Petit_Banc_Pied = object
{
union	{
	cylinder { <0, 0, 0>, <0, H_banc, 0>, 0.016 }
	cylinder { <0, 0, 0>, <0, 0.01, 0>,   0.026 }
	}
}

//		------------------

#macro Petit_Banc_Les_Pieds(Col)

union	{
	#local dx = La_banc - 0.04;
	#local dz = Lo_banc - 0.15;
	object { Petit_Banc_Pied      translate <-dx, 0, -dz> }
	object { Petit_Banc_Pied      translate < dx, 0, -dz> }
	object { Petit_Banc_Pied      translate <-dx, 0,  dz> }
	object { Petit_Banc_Pied      translate < dx, 0,  dz> }
	#local H = 0.15;
	cylinder { <-dx, H, -dz>, <dx, H, -dz>, 0.012 }
	cylinder { <-dx, H,  dz>, <dx, H,  dz>, 0.012 }
	cylinder { <0, H, -dz>, <0, H_banc, 0>, 0.010 }
	cylinder { <0, H,  dz>, <0, H_banc, 0>, 0.010 }
	}
texture {
	pigment { color Col }
	finish { phong PHONG specular SPECULAR }
	}
#end

//		------------------

#declare Petit_Banc_Planche = object
{
box { <-La_banc, 0, -Lo_banc>, <La_banc, 0.022, Lo_banc> }
texture { T_Wood1 rotate <2, 3, 5> }
}

//		------------------
#macro Petit_Banc(ColPied)
union	{
	object { Petit_Banc_Planche      translate y*H_banc	}
	object { Petit_Banc_Les_Pieds(ColPied)			}
	}
#end
/*    ======================================================    */
/*
 *	et la on va assembler quelques-uns de ces meubles
 *	pour creer des espaces conviviaus propices aux
 *	bavardages débridés.
 */
#declare Table_Basse_Deux_Bancs = object
{
union	{
	object { Petit_Banc(Orange) rotate  y*6 translate  0.94*x        }
	object { Table_Basse                                             }
	object { Petit_Banc(Green)  rotate -y*5 translate -1.02*x        }
	object { Assiette_0 scale 2 translate <0.04, TB_haut+0.04, 0.11> }
	}
}
#declare Table_Haute_Deux_Bancs = object
{
union	{
	object { Petit_Banc(Brown) rotate 2*y	translate <-1.11, 0, 0.15>   }
	object { Une_Table rotate y*5		translate < 0, 0, 0>         }
	object { Petit_Banc(Brown)		translate < 1.08, 0, 0.10>   }
	object { Chaise_Rasta		rotate y*187 translate <0, 0,  1.84> }
	object { Chaise_Rasta		rotate y*4   translate <0, 0, -1.72> }
	}
rotate 10*y
}
#declare Le_Coin_Bouffe = object
{
union	{
	object { Table_Ronde   rotate    -9*y   }
	object { Chaise_Jaune  rotate    96*y translate <-1.09, 0,   0.00> }
	object { Chaise_1      rotate   201*y translate < 1.51, 0,   0.00> }
	object { Chaise_1      rotate   184*y translate < 0.07  0,   1.17> }
	object { Chaise_Grise                 translate < 0.10, 0,  -1.09> }
	object { Un_Tabouret(Coral)           translate <-1.66, 0,   1.54> }
	object { Un_Tabouret(DarkTan)         translate <-1.66, 0,  -1.54> }
	}
}
/*    ======================================================    */
//		nouveau: Sat 07 Jan 2023 09:14:52 PM CET
#declare Quelques_Sieges = object
{
#local Ec = 0.86;
union	{
	object { Chaise_1  		rotate  y*99
		  			translate <-Ec, 0,  Ec*0.55>	}
	object { Chaise_Rasta  		rotate -y*105
					translate < Ec, 0,  Ec*0.51>	}

	object { Un_Tabouret(Brown)	translate <-Ec, 0, -Ec*0.80>	}
	object { Petit_Banc(Gray60)					}
	}
}

/*    ------------------------------------------------------    */

